<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

require_once 'lib/PHPExcel/Classes/PHPExcel.php';

/** PHPExcel_Writer_Excel2007 */
require_once 'lib/PHPExcel/Classes/PHPExcel/Writer/Excel5.php';
require_once 'lib/PHPExcel/Classes/PHPExcel/Reader/Excel5.php';

/**
 * Description of xlsTableDB
 *
 * @author gustavo
 */
class xlsTableDB extends dataTableDB {

    private $objPHPExcel;
    private $objWriter;
    private $titles = false;
    private $first_row = 10;
    private $first_col = 0;
    private $dataArray = array();

    const file_type = 'Excel5';

    function __construct() {
        $this->dataTableDB();
    }

    public function getFirst_row() {
        return $this->first_row;
    }

    public function setFirst_row($first_row) {
        $this->first_row = $first_row;
    }

    public function getFirst_col() {
        return $this->first_col;
    }

    public function setFirst_col($first_col) {
        $this->first_col = $first_col;
    }

    public function addData_toArray($col, $row, $value) {
        $array = array();
        $array['col'] = $col;
        $array['row'] = $row;
        $array['value'] = $value;
        $this->dataArray[] = $array;
    }

    public function setXlsData() {

        $_flag = false;
        $_ret = new statusResponse();

        try {
            if (!$this->objPHPExcel)
                $this->InitXls();

            $this->objPHPExcel->setActiveSheetIndex(0);

            // $this->setTitles();

            $j = $this->first_row + 1;

            if ($this->resultSet) {

                foreach ($this->dataArray as $array) {

                    $value = $array['value'];
                    $varType = null;
                    
                    if (is_object($value))
                        $varType = strtolower(get_class($value));
                    if ($varType == dtTableField::TYPE_DATE) {
                        $value = DateConversion::DateToViewFormat($value);
                    } elseif ($varType == dtTableField::TYPE_DATE_TIME) {
                        $value = DateConversion::DateTimeToViewFormat($value);
                    }
                    $this->objPHPExcel->getActiveSheet()->SetCellValueByColumnAndRow($array['col'], $array['row'], $value);
                }

                while ($aRow = $this->resultSet->fetchRow(MDB2_FETCHMODE_ASSOC)) {

                    $i = $this->first_col;

                    foreach ($this->fieldFormatedList as $field) {

                        if ($field->getType() != dtTableField::TYPE_DATE && $field->getType() != dtTableField::TYPE_DATE_TIME) {
                            $data = $aRow[$field->getName()];
                        } else {
                            $value = $field->getFormattedValue($aRow[$field->getName()]);
                            $data = $value;
                        }

                        $this->objPHPExcel->getActiveSheet()->SetCellValueByColumnAndRow($i, $j, $data);
                        $i++;
                        $_flag = true;
                    }

                    $j++;
                }
            } else {

                $_ret = statusResponse::getInstance_No_Save_data("no hay datos en la hoja de ruta");
            }
        } catch (Exception $e) {
            $_ret = statusResponse::getInstanceFromException($e);
        }

        if ($_flag and ! $_ret->getStatusCode()) {
            $_ret = statusResponse::getInstanceOk();
        }

        return $_ret;
    }

    public function writeXls($file) {
        $this->objWriter = new PHPExcel_Writer_Excel5($this->objPHPExcel);
        $this->objWriter->save($file);
    }

    public function InitXls() {
// Create new PHPExcel object
        $this->objPHPExcel = new PHPExcel();

// Set properties
        $this->objPHPExcel->getProperties()->setCreator("PlanetOffice");
        $this->objPHPExcel->getProperties()->setLastModifiedBy("PlanetOffice");
        $this->objPHPExcel->getProperties()->setTitle("Hoja de ruta del dia");
        // $this->objPHPExcel->getProperties()->setSubject("Hoja de ruta");
        // $this->objPHPExcel->getProperties()->setDescription("Hoja de ruta");
    }

    public function openXls($file) {
        $this->objReader = PHPExcel_IOFactory::createReader(self::file_type);
        $this->objPHPExcel = $this->objReader->load($file);
    }

    private function setTitles() {
        $i = $this->first_col;
        foreach ($this->fieldFormatedList as $key => $field) {
            //$field = new dtTableField($name);
            $this->objPHPExcel->getActiveSheet()->SetCellValueByColumnAndRow($i, $this->first_row, $field->getColumnName());
            $i++;
        }
    }

    public function SendXlsHeaders() {
        header('Content-type: application/vnd.ms-excel');
        header('Content-Disposition: attachment; filename="hojaruta.xls"');
    }

}

?>
