<?php
require_once 'lib/config/appConfig.class.php';

class SessionVars {
	
	const SESSION_LASTTIME_CTRL = "lasttime";
	const USERID_VARNAME = "g_userid";
	const DEBUG_MODE_VAR_NAME = "debug"; // modo debug para mostrar o no los errores
	const MANAGEDSCOPE_EMPRESA_VARNAME = "ms_empresa";
	const MANAGEDSCOPE_DEPARTAMENTO_VARNAME = "ms_depto";
	const EMPRESAS = "empresas";
	const DEPARTAMENTOS = "departamentos";
	
	private static $expiredSession;

	public function SessionVars() {

	}

	/**
	 *
	 * @param
	 *        	bool, modo on => true, modo off => false
	 */
	public static function setDebugMode($value) {

		$_SESSION [SessionVars::DEBUG_MODE_VAR_NAME] = $value;
	}

	public static function getDebugMode() {

		return $_SESSION [SessionVars::DEBUG_MODE_VAR_NAME];
	}

	public static function start() {

		session_name ( appConfig::SESSION_NAME );
		session_start ();
		SessionVars::sessionTimeControl ();
	}

	private static function sessionTimeControl() {

		$_actualTime = time ();
		$_lastTime = SessionVars::getSessionLastTime ();
		$_expireTime = $_lastTime + appConfig::SESSION_TIMEOUT;
		SessionVars::$expiredSession = false;
		
		if (isset ( $_lastTime ) and $_lastTime > 0) {
			if ($_actualTime > $_expireTime) { // Sesion vencida
				SessionVars::$expiredSession = true;
				SessionVars::clearVars ();
			}
		}
		
		SessionVars::setSessionLastTime ( $_actualTime );
	}

	/**
	 * SESSION HANDLER FOR THE USER ID *
	 */
	public static function setUserId($usid) {

		$_SESSION [SessionVars::USERID_VARNAME] = $usid;
	}

	public static function getUserId() {

		return $_SESSION [SessionVars::USERID_VARNAME];
	}

	public static function clear() {

		session_unset ();
		session_destroy ();
	}

	public static function clearVars() {

		session_unset ();
	}

	public static function getSessionId() {

		return session_id ();
	}

	public static function getSessionLastTime() {

		return $_SESSION [SessionVars::SESSION_LASTTIME_CTRL];
	}

	public static function setSessionLastTime($timestamp) {

		$_SESSION [SessionVars::SESSION_LASTTIME_CTRL] = $timestamp;
	}

	public static function isExpiredSession() {

		return SessionVars::$expiredSession;
	}
	
}

?>
