<?php

require_once 'lib/customlib/database/DbConfig.class.php';
require_once 'lib/customlib/customMessage/msgTable.php';

/**
 * Description of dao2
 *
 * @author pc3
 */
class dao2  {

    static protected $db = null;
    private $transaction_savepoint;
    private $nested_transaction = false;

    function __construct() {        
    }

    public function dbConnect() {
        
        if (dao2::$db == null) {
            dao2::$db = DbConfig::getDBConnection();
                                    
            if (DbConfig::isError(dao2::$db))
                throw msgTable::getExceptionFromTableMsgCode(msgTable::EXCEPTION_DATABASE_DAO2_CONNECTIONFAIL);
        }

        return dao2::$db;
    }

    static public function dbClose() {
        DbConfig::disconnect();
    }


    static public function BeginTransaction() {
        $dao2 = new dao2();
        $dao2->dbConnect();

        if (!dao2::$db->supports('transactions')) {
            throw msgTable::getExceptionFromTableMsgCode( msgTable::EXCEPTION_DATABASE_DAO2_TRANSACTIONNOTSUPORTED, "BeginTransaction");
        } else {
            if (dao2::$db->inTransaction() ) {

                $dao2->transaction_savepoint = dao2::$db->beginNestedTransaction();
                $dao2->nested_transaction = true;
            } else {

                dao2::$db->beginTransaction();
            }
        }

        return $dao2;
    }

    static public function BeginNestedTransaction() {
        $dao2 = new dao2();
        $dao2->dbConnect();

        if (!dao2::$db->supports('transactions')) {
            throw msgTable::getExceptionFromTableMsgCode( msgTable::EXCEPTION_DATABASE_DAO2_TRANSACTIONNOTSUPORTED, "BeginNestedTransaction");
        } else {

            $dao2->nested_transaction = true;
            $dao2->transaction_savepoint = dao2::$db->beginNestedTransaction();
        }

        return $dao2;
    }

    public function Commit() {
        if (!dao2::$db->supports('transactions')) {
            throw msgTable::getExceptionFromTableMsgCode( msgTable::EXCEPTION_DATABASE_DAO2_TRANSACTIONNOTSUPORTED, "Commit");
        } else {
            if ($this->nested_transaction) {
                dao2::$db->completeNestedTransaction();
            } else {
                dao2::$db->Commit();
            }
        }
    }

    public function Rollback() {
        if (!dao2::$db->supports('transactions')) {
            throw msgTable::getExceptionFromTableMsgCode( msgTable::EXCEPTION_DATABASE_DAO2_TRANSACTIONNOTSUPORTED, "Rollback");
        } else {
            if ($this->nested_transaction) {
                dao2::$db->failNestedTransaction();
            } else {
                dao2::$db->Rollback();
            }

        }
    }

}
