<?php

require_once 'DbConfig.class.php';
require_once 'mysqlDAO.class.php';
require_once 'DbCharsetEncoding.php';
require_once 'statusResponse.php';
//require_once 'lib/mimundo/admin/common/date_conversion/DateConversion.php';
//require_once 'lib/mimundo/admin/customMessage/statusResponse.php';

/**
 * Description of DAO
 *
 * @author pc1
 */
class DAO extends mysqlDAO {
    
    const TRANSACTION_SUPPORTED = true;

    static private $db;
    static protected $cursor;
    static protected $emptySet = false;
    static protected $numRows = 0;
    static protected $affectedRows;
    static protected $exception;
    static protected $table_param;
    static protected $statusResponse;
    static private $lastInsertId = -1;
    
    static private $nested_transaction = false;
    static private $savepoint;

    private static function dbConnect() {
        if (DAO::$db == null) {
            DAO::$db = DbConfig::getDBConnection();
	    print_r(DAO::$db);
            if (DbConfig::isError(DAO::$db)) throw new Exception("Error al conectar a la base");
        }        
    }
    
    static public function getDB() {
        return self::$db;
    }

    static public function BeginTransaction() {
        DAO::dbConnect();

        $_ret = DAO::$db->supports('transactions');        
        // FB::info(DAO::$db, DAO::$db->supports('transactions'));
        // if (!DAO::$db->supports('transactions')) {
        if (!self::TRANSACTION_SUPPORTED) {
            throw new Exception("RDMBS no soporta transacciones - begin transaction");
        } else {
            if (DAO::$db->inTransaction() ) {    
                
                self::$savepoint = DAO::$db->beginNestedTransaction();
                self::$nested_transaction = true;
            } else {
                self::$nested_transaction = false;
                DAO::$db->beginTransaction();
            }
        }
    }
    
    static public function BeginNestedTransaction() {
        self::dbConnect();
        self::$savepoint = DAO::$db->beginNestedTransaction();
        self::$nested_transaction = true;        
    }

    static public function Commit() {
        self::dbConnect();

        if (!DAO::$db->supports('transactions')) {
            throw new Exception("RDMBS no soporta transacciones");
        } else {
            
            if (self::$nested_transaction) {
                DAO::$db->completeNestedTransaction();
            } else {
                DAO::$db->Commit();            
            }                        
        }
            
                    
    }

    static public function Rollback() {
        self::dbConnect();

        if (!DAO::$db->supports('transactions')) {
            throw new Exception("RDMBS no soporta transacciones");
        } else {

            if (self::$nested_transaction) {
                DAO::$db->failNestedTransaction();
            } else {
                DAO::$db->Rollback();
            }                        
                
        }
    }

    static public function dbClose() {
        DbConfig::disconnect();
    }

    static public function getMDB2_ERROR() {
        if (get_class(DAO::$cursor) == "MDB2_Error")
            return DAO::$cursor;
        return false;
    }

    static public function getLastInsertId() {
        return DAO::$lastInsertId;
    }

    static public function isEmptySet() {
        return DAO::$emptySet;
    }

    static public function isError() {
        return PEAR::isError(DAO::$cursor);
    }

    static public function getFieldType($fieldName) {
        return self::$table_param['field_types'][$fieldName];
    }

    static public function getDatabaseDateFormat() {
        return DbConfigDataForType::$dateTimeFormat;
    }

    static public function getDatabaseDateNullValue() {
        return DbConfigDataForType::$dateNullValue;
    }

    static protected function getFirstResult($id) {

        $_table = self::$table_param["table"];

        $_primary_key = self::$table_param["primary_key"];
        $_join_table = self::$table_param["join_tables"];
        $_fieldTypes = self::$table_param["field_types"];
        
        $_additional_select_fields = self::$table_param["additional_select_fields"];

        $_fieldsStr = "";
        if ($_fieldTypes !== null) {
            foreach ($_fieldTypes as $key => $value) {
                $_fieldsStr .= self::formatFieldSelect($value, $key) . ",";
            }
            $_fieldsStr = substr($_fieldsStr, 0, strlen($_fieldsStr) - 1);
            if ($_additional_select_fields)
                $_fieldsStr .= " ,$_additional_select_fields ";
        } else {
            $_fieldsStr .= " * ";
        }

        if (is_array($_join_table)) {

            $_where = "where $_table.$_primary_key = '$id' ";

            $_from = " from $_table ";
            $_from .= self::getQueryFrom_WithJoinTables();
            $_from .= self::getQueryFrom_WithLeftJoinTables();

            $_query = "select $_fieldsStr $_from $_where ";
        } else {
            $_query = "select $_fieldsStr from $_table where $_table.$_primary_key = '$id' ";
        }
        //echo $_query;
        $_row = false;

        try {

            DAO::dbConnect();
                $_cursor = DAO::$db->query($_query);
                DAO::$cursor = &$_cursor;

                if (!DbConfig::isError($_cursor)) {
                    $numRows = DAO::$cursor->numRows();
                    DAO::$numRows = $numRows;
                    DAO::$statusResponse = statusResponse::getInstanceOk();

                    if ($numRows > 0) {
                        $_row = self::getNextRow(); //DAO::$cursor->fetchRow(MDB2_FETCHMODE_ASSOC);
                        DAO::$emptySet = false;
                    } else {
                        DAO::$emptySet = true;
                    }
                } else {

                    DAO::$emptySet = true;
                    DAO::$statusResponse = statusResponse::getInstanceForMDBError(DAO::$cursor);
                    // error en consulta TODOO debug
                }
        } catch (Exception $e) {
            DAO::$exception = $e;
            DAO::$statusResponse = statusResponse::getInstanceFromException($e);
        }

        return $_row;
    }
    
    static protected function getFirstResultFromQuery($_query) {
		
        $_row = false;
        try {

            DAO::dbConnect();
            $_cursor = DAO::$db->query($_query);
            DAO::$cursor = &$_cursor;

            if (!DbConfig::isError($_cursor)) {
                $numRows = DAO::$cursor->numRows();
                DAO::$numRows = $numRows;

                if ($numRows > 0) {
                    $_row = self::getNextRow(); //DAO::$cursor->fetchRow(MDB2_FETCHMODE_ASSOC);
                    DAO::$emptySet = false;
                } else {
                    DAO::$emptySet = true;
                }
            } else {

                DAO::$emptySet = true;
                DAO::$statusResponse = statusResponse::getInstanceForMDBError(DAO::$cursor);
                // error en consulta TODOO debug
            }
        } catch (Exception $e) {

            DAO::$exception = $e;
            DAO::$statusResponse = statusResponse::getInstanceFromException($e);
        }

        return $_row;
    }   
    
    static protected function getSelection() {
        $_table = self::$table_param["table"];

        $_primary_key = self::$table_param["primary_key"];
        $_join_table = self::$table_param["join_tables"];
        $_fieldTypes = self::$table_param["field_types"];
        $_additional_select_fields = self::$table_param["additional_select_fields"];

        $_fieldsStr = "";
        if ($_fieldTypes !== null) {
            foreach ($_fieldTypes as $key => $value) {

                $_fieldsStr .= self::formatFieldSelect($value, $key) . ",";
            }
            $_fieldsStr = substr($_fieldsStr, 0, strlen($_fieldsStr) - 1);
            if ($_additional_select_fields)
                $_fieldsStr .= " ,$_additional_select_fields ";
        } else {
            $_fieldsStr .= " * ";
        }
        
        return $_fieldsStr;
    }

    static protected function getFirstResultFromWhere($where, $order = null) {

        $_table = self::$table_param["table"];

        $_primary_key = self::$table_param["primary_key"];
        $_join_table = self::$table_param["join_tables"];
        $_fieldTypes = self::$table_param["field_types"];
        $_additional_select_fields = self::$table_param["additional_select_fields"];

        $_fieldsStr = "";
        if ($_fieldTypes !== null) {
            foreach ($_fieldTypes as $key => $value) {

                $_fieldsStr .= self::formatFieldSelect($value, $key) . ",";
            }
            $_fieldsStr = substr($_fieldsStr, 0, strlen($_fieldsStr) - 1);
            if ($_additional_select_fields)
                $_fieldsStr .= " ,$_additional_select_fields ";
        } else {
            $_fieldsStr .= " * ";
        }

        if (is_array($_join_table)) {

            $_where = "where $where ";

            $_from = " from $_table ";
            $_from .= self::getQueryFrom_WithJoinTables();
            $_from .= self::getQueryFrom_WithLeftJoinTables();

            $_query = "select $_fieldsStr $_from $_where ";
        } else {
            $_query = "select $_fieldsStr from $_table where $where ";
        }

        if ($order != null) {
            $_query .= " ORDER BY $order";
        }

        //echo $_query;
        $_row = false;

        try {

            DAO::dbConnect();
            $_cursor = DAO::$db->query($_query);
            DAO::$cursor = &$_cursor;

            if (!DbConfig::isError($_cursor)) {
                $numRows = DAO::$cursor->numRows();
                DAO::$numRows = $numRows;
                DAO::$statusResponse = statusResponse::getInstanceOk();

                if ($numRows > 0) {
                    $_row = self::getNextRow(); //DAO::$cursor->fetchRow(MDB2_FETCHMODE_ASSOC);
                    DAO::$emptySet = false;
                } else {
                    DAO::$emptySet = true;
                }
            } else {

                DAO::$emptySet = true;
                DAO::$statusResponse = statusResponse::getInstanceForMDBError(DAO::$cursor);
                // error en consulta TODOO debug
            }
        } catch (Exception $e) {

            DAO::$exception = $e;
            DAO::$statusResponse = statusResponse::getInstanceFromException($e);
        }

        return $_row;
    }

    /**
     * 
     * @param type $id
     * @param type $where_expression
     * @param type $order
     * @return type
     */
    static protected function getResults($id = false, $where_expression = "", $order = "") {

        $_query = self::getQueryForResults($id, $where_expression, $order);
        //echo $_query;

        return self::getResultsFromQuery($_query);
    }

    /**
     *
     * @param $id, clave de busqueda para retorno de tuplas
     * si existe en el table_param un join_tables, entonces utiliza el $id para la clave primaria y la junta de join para juntar las tablas
     * si no entonces utiliza la key de table_param para componer el where con el key=$id.
     * Opcionalmente puede usar el where_expression y el order
     *
     * @return int -1 error, 0 sin resultados, >0 ok cantidad de resultados
     */
    static protected function getQueryForResults($id = false, $where_expression = "", $order = "") {

        $_where = "";
        $_alias = self::$table_param["alias"];
        $_table = self::$table_param["table"];
        $_select = self::$table_param["select"];

        if (!$_select and $_alias)
            $_select = "SELECT DISTINCT $_alias.*";
        if (!$_select)
            $_select = "select * ";

        /*
        $_additional_select_fields = self::$table_param["additional_select_fields"];
        
        if ($_additional_select_fields) {
                $_select .= ", $_additional_select_fields ";
        }
        */
        $_primary_key = self::$table_param["primary_key"];
        $_key = self::$table_param["key"];
        $_join_table = self::$table_param["join_tables"];
        $_left_join_table = self::$table_param["left_join_tables"];

        if (is_array($_join_table)) {

            $_from = "from $_table $_alias";
            if ($id !== false) {

                $_where = "where ";

                if ($_primary_key)
                    $_where .= " $_primary_key = $id ";
                if ($_key)
                    $_where .= " $_key = $id ";

                $_from .= self::getQueryFrom_WithJoinTables();
                if (is_array($_left_join_table)) {
                    $_from .= self::getQueryFrom_WithLeftJoinTables();
                }
            } else {
                $_from .= self::getQueryFrom_WithJoinTables();
                if (is_array($_left_join_table)) {
                    $_from .= self::getQueryFrom_WithLeftJoinTables();
                }
            }
            if ($where_expression) {
                $_where = "where ";
                $_where .= " $where_expression ";
            }

            $_query = "$_select $_from $_where ";
        } elseif (is_array($_left_join_table)) {
            $_from = "from $_table $_alias";
            if ($id !== false) {

                $_where = "where ";

                if ($_primary_key)
                    $_where .= " $_primary_key = $id ";
                if ($_key)
                    $_where .= " $_key = $id ";
            } else {

                $_from .= self::getQueryFrom_WithLeftJoinTables();
            }
            if ($where_expression) {
                $_where = "where ";
                $_where .= " $where_expression ";
            }
            $_query = "$_select $_from $_where ";
        } else {


            if ($where_expression) {

                $_query = "$_select from $_table $_alias where $where_expression";
            } else {

                if ($id !== false) {

                    $_query = "$_select from $_table $_alias where $_key = $id";
                } else {
                    $_query = "$_select from $_table $_alias ";
                }
            }
        }

        if ($order)
            $_query .= " order by $order ";



        // FB::info($_query);
        return $_query;
    }

    /**
     * Retorna la cantidad de filas resultado de la consulta. Para acceder a dichas filas utilizar acceso estatico getNextRow
     * 
     * @param String $_query
     * @return int
     */
    static public function getResultsFromQuery($_query) {
        //echo $_query;
        $_row = false;
        $_ret = -1;

        try {
            DAO::dbConnect();
            $_cursor = DAO::$db->query($_query);
            DAO::$cursor = &$_cursor;

            if (!DbConfig::isError($_cursor)) {
                $numRows = DAO::$cursor->numRows();

                DAO::$numRows = $numRows;

                if ($numRows > 0) {
                    $_ret = $numRows;
                    DAO::$emptySet = false;
                } else {

                    $_ret = 0;
                    DAO::$emptySet = true;
                }
            } else {
                $_ret = -1;
                DAO::$emptySet = true;
                DAO::$statusResponse = statusResponse::getInstanceForMDBError(DAO::$cursor);

		// error en consulta TODOO debug
            }
        } catch (Exception $e) {
            $_ret = -5;
            DAO::$exception = $e;
            DAO::$statusResponse = statusResponse::getInstanceFromException($e);
        }
	
        return $_ret;
    }

    static protected function getNextRow() {
        return self::getNextRowFromCursor(DAO::$cursor);
    }

    static public function getNextRowFromCursor($cursor){
        $_row = $cursor->fetchRow(MDB2_FETCHMODE_ASSOC);

        foreach ($_row as $field => $value){
            if(is_array(DAO::$table_param) && DAO::$table_param['field_types'][$field]){
                $_row[$field] = DbCharsetEncoding::fromDbEncoding($value, DAO::$table_param['field_types'][$field]);
            }else{
                $_row[$field] = DbCharsetEncoding::fromDbEncoding($value);
            }
        }

        return $_row;
    }



    static protected function Insert(Array $field_values) {

        $_primary_key = self::$table_param["primary_key"];

        /** TODO revisar codificacion
          foreach ($field_values as $key => $value) {
          $field_values[$key] = iconv("utf-8", "iso-8859-1", $value);
          }         
         */
        
        $_table = self::$table_param["table"];

        $_fields = "";
        $_values = "";
        $_sep = "";

        foreach ($field_values as $field => $value) {
            if ($field != $_primary_key) {
                
                $_fields .= "$_sep $field";
                $_value = self::formatFieldInsert(self::$table_param["field_types"][$field], $value);
                $_value = DbCharsetEncoding::toDbEncoding($_value,self::$table_param["field_types"][$field]);
                $_values .= "$_sep " . $_value; 
                                
                $_sep = ",";
            }
        }

        $sql = "INSERT INTO $_table ( $_fields ) VALUES ( $_values )";
        // FB::info($sql);
        

        try {
            DAO::dbConnect();
            DAO::$affectedRows = & DAO::$db->exec($sql);
            DAO::$cursor = DAO::$affectedRows;

            $_ret = 1;
            // Always check that result is not an error
            if (PEAR::isError(DAO::$affectedRows)) {
                DAO::$emptySet = true;
                DAO::$statusResponse = statusResponse::getInstanceForMDBError(DAO::$cursor);
                $_ret = -1;
            } else {

                $_id = self::$table_param["primary_key"];

                //DAO::$lastInsertId = DAO::$db->lastInsertID($_table);
                DAO::$lastInsertId = DAO::$db->lastInsertID($_id);
                $_ret = DAO::$lastInsertId;
                
                DAO::$statusResponse = statusResponse::getInstanceOk();
            }
        } catch (Exception $e) {

            $_ret = -5;
            DAO::$exception = $e;
            DAO::$statusResponse = statusResponse::getInstanceFromException($e);
        }

        return $_ret;
    }

    /**
     * Sql update
     *
     * @param array $field_values_where_exp
     * @param array $field_values
     * @return Integer, affected number of rows, -1 if error
     */
    static protected function Update(Array $field_values_where_exp, Array $field_values) {

        /* TODO revisar conversion
          foreach ($field_values as $key => $value) {
          $field_values[$key] = iconv("utf-8", "iso-8859-1", $value);
          }
         * 
         */

        $_ret = -1;
        $_table = self::$table_param["table"];
        $_fields = array();
        $_values = array();
        $_sep = "";
        $_exp = "";
        
        

        foreach ($field_values as $field => $value) {
            $_value = self::formatFieldInsert(self::$table_param["field_types"][$field], $value);
            $_value = DbCharsetEncoding::toDbEncoding($_value, self::$table_param["field_types"][$field]);
            $_exp .= "$_sep $field=$_value";
            $_sep = ",";
        }
        
        
                
        $_sep = "";
        $_where_exp = "";
        foreach ($field_values_where_exp as $field => $value) {
            $_value = self::formatFieldInsert(self::$table_param["field_types"][$field], $value);
            $_value = DbCharsetEncoding::toDbEncoding($_value, self::$table_param["field_types"][$field]);
            $_where_exp .= " $_sep $field=$_value";
            $_sep = " and ";
        }

        
        
        $sql = "UPDATE $_table SET $_exp WHERE $_where_exp";
        // echo $sql."\n";
        
                

        try {
            DAO::dbConnect();
            
            DAO::$affectedRows = &DAO::$db->exec($sql);            
            DAO::$cursor = DAO::$affectedRows;
            
            // var_dump(DAO::$affectedRows);

            // Always check that result is not an error
            if (PEAR::isError(DAO::$affectedRows)) {
                DAO::$emptySet = true;
                DAO::$statusResponse = statusResponse::getInstanceForMDBError(DAO::$cursor);
                $_ret = -1;
            } else {
                $_ret = DAO::$affectedRows;
                DAO::$statusResponse = statusResponse::getInstanceOk();
            }
        } catch (Exception $e) {
            $_ret = -5;
            DAO::$exception = $e;
            DAO::$statusResponse = statusResponse::getInstanceFromException($e);
        }

        return $_ret;
    }

    /**
     * Sql update
     *
     * @param array $field_values_where_exp
     * @param array $field_values
     * @return Integer, affected number of rows, -1 if error
     */
    static protected function Delete(Array $field_values_where_exp) {

        $_ret = -1;
        $_table = self::$table_param["table"];
        $_fields = array();
        $_values = array();
        $_sep = "";
        $_exp = "";
        $_where_exp = "";

        $_sep = "";
        $_where_exp;
        foreach ($field_values_where_exp as $field => $value) {
            $_where_exp .= " $_sep $field='$value' ";
            $_sep = " and ";
        }

        $sql = "DELETE FROM $_table WHERE $_where_exp";
        //echo $sql;
        try {
            DAO::dbConnect();
            DAO::$affectedRows = & DAO::$db->exec($sql);
            DAO::$cursor = DAO::$affectedRows;

            // Always check that result is not an error
            if (PEAR::isError(DAO::$cursor)) {
                DAO::$emptySet = true;
                DAO::$statusResponse = statusResponse::getInstanceForMDBError(DAO::$cursor);
                $_ret = -1;
            } else {
                $_ret = DAO::$affectedRows;
                DAO::$statusResponse = statusResponse::getInstanceOk();
            }
        } catch (Exception $e) {
            $_ret = -5;
            DAO::$exception = $e;
            DAO::$statusResponse = statusResponse::getInstanceFromException($e);
        }

        return $_ret;
    }

    static protected function UpdateByPrimaryKey($primaryKeyValue, Array $field_values) {
        $_primary_key = self::$table_param["primary_key"];

        $_field_values_where_exp = array("$_primary_key" => "$primaryKeyValue");

        
        return DAO::Update($_field_values_where_exp, $field_values);
    }

    /**
     * Realiza un replace, o sea un update si encuentra la clave primaria o un insert si no lo encuentra.
     * Retorna 0 si hace un update, 1 si realiza un insert y valores negativos en caso de error
     * 
     * @param type $primaryKeyValue
     * @param array $field_values
     * @return int
     */
    static protected function Update_Insert_ByPrimaryKey($primaryKeyValue, Array $field_values) {
        $_ret = -1;
        $_primary_key = self::$table_param["primary_key"];
        $_field_values_where_exp = array("$_primary_key" => "$primaryKeyValue");

        $obj = self::getFirstResult($primaryKeyValue);

        if ($obj) {

            $_result = DAO::Update($_field_values_where_exp, $field_values);
            if ($_result >= 0)
                $_ret = 0;
        } else {

            $_result = DAO::Insert($field_values);
            if ($_result >= 0)
                $_ret = $_result;
        }

        return $_ret;
    }

    static protected function DeleteByPrimaryKey($primaryKeyValue) {
        $_primary_key = self::$table_param["primary_key"];
        $_field_values_where_exp = array("$_primary_key" => "$primaryKeyValue");

        return DAO::Delete($_field_values_where_exp);
    }

    static public function getAffectedRows() {
        return DAO::$affectedRows;
    }

    static public function getCursor() {
        return DAO::$cursor;
    }

    static public function getStatusResponse() {
        return DAO::$statusResponse;
    }

    static protected function getAsynchronousSeekerResults($_query) {
        //echo "query:".$_query;

        $_rows = false;
        try {

            DAO::dbConnect();
            $_cursor = DAO::$db->query($_query);
            DAO::$cursor = &$_cursor;

            if (!DbConfig::isError($_cursor)) {
                $numRows = DAO::$cursor->numRows();
                DAO::$numRows = $numRows;
                $_rows = array();
                DAO::$statusResponse = statusResponse::getInstanceOk();
                if ($numRows > 0) {
                    for ($i = 1; $i <= $numRows; $i++) {
                        $_rows[] = DAO::getNextRow();
                    }
                    DAO::$emptySet = false;
                } else {
                    DAO::$emptySet = true;
                }
            } else {

                DAO::$emptySet = true;
                DAO::$statusResponse = statusResponse::getInstanceForMDBError(DAO::$cursor);
                // error en consulta TODOO debug
            }
        } catch (Exception $e) {

            DAO::$exception = $e;
            DAO::$statusResponse = statusResponse::getInstanceFromException($e);
        }

        return $_rows;
    }

    static protected function getSimpleFirstResult($id) {
        $_table = self::$table_param["table"];
        $_primary_key = self::$table_param["primary_key"];

        $_query = "select * from $_table where $_primary_key = '$id' ";

        $_row = false;

        //echo $_query;

        try {

            DAO::dbConnect();
            $_cursor = DAO::$db->query($_query);
            DAO::$cursor = &$_cursor;

            if (!DbConfig::isError($_cursor)) {
                $numRows = DAO::$cursor->numRows();
                DAO::$numRows = $numRows;

                DAO::$statusResponse = statusResponse::getInstanceOk();
                if ($numRows > 0) {
                    $_row = self::getNextRow(); //DAO::$cursor->fetchRow(MDB2_FETCHMODE_ASSOC);
                    DAO::$emptySet = false;
                } else {
                    DAO::$emptySet = true;
                }
            } else {

                DAO::$emptySet = true;
                DAO::$statusResponse = statusResponse::getInstanceForMDBError(DAO::$cursor);
                // error en consulta TODOO debug
            }
        } catch (Exception $e) {

            DAO::$exception = $e;
            DAO::$statusResponse = statusResponse::getInstanceFromException($e);
        }

        return $_row;
    }

    static protected function getQueryFrom_WithJoinTables() {

        $_table = self::$table_param["table"];
        $_alias = self::$table_param["alias"];
        $_join_table = self::$table_param["join_tables"];

        $_from = "";

        foreach ($_join_table as $_jtable => $_joinKeyArr) {
            $_from .= " join $_jtable on (";
            $_op = "";
            foreach ($_joinKeyArr as $_jf1 => $_jf2) {

                $_from .= " $_op $_jf1 = $_jf2 ";
                $_op = " and ";
            }
            $_from .= " ) ";
        }

        return $_from;
    }

    static protected function getQueryFrom_WithLeftJoinTables() {

        $_table = self::$table_param["table"];
        $_join_table = self::$table_param["left_join_tables"];

        $_from = "";

        if (is_array($_join_table)) {
            foreach ($_join_table as $_jtable => $_joinKeyArr) {
                $_from .= " left join $_jtable on (";
                $_op = "";
                foreach ($_joinKeyArr as $_jf1 => $_jf2) {

                    $_from .= " $_op $_jf1 = $_jf2 ";
                    $_op = " and ";
                }
                $_from .= " ) ";
            }
        }

        return $_from;
    }

    static protected function getRsInstantiatedObj_revisar(&$obj, &$resultSet) {

        $_ret = &$obj;

        if ($_fieldTypes !== null) {
            foreach ($_fieldTypes as $key => $type) {
                $value = $resultSet[$key];
                $method = "set" . ucfirst($key);
                //echo "<br>  $key $method: $value";
                if ($value) {
                    if (method_exists(get_class($obj), $method)) {
                        if (self::getFieldType($key) == "datetime")
                            $_ret->$method(DateConversion::DBFormatToDateTime($value));
                        else if (self::getFieldType($key) == "date")
                            $_ret->$method(DateConversion::DBFormatToDate($value));
                        else
                            $_ret->$method($value);
                    }
                }
            }
        }

        return $_ret;
    }

    static protected function getRsInstantiatedObj(&$obj, &$resultSet) {

        $_ret = &$obj;
        
        foreach ($resultSet as $key => $value) {
            $key = strtolower($key);
            $method = "set" . ucfirst($key);            
                        
            if (method_exists(get_class($obj), $method)) {
                if (self::getFieldType($key) == "datetime"){                                                           
                    $_ret->$method(DateConversion::DBFormatToDateTime($value));
                }
                else if (self::getFieldType($key) == "date"){
                    $_ret->$method(DateConversion::DBFormatToDate($value));
                }
                else {
                    $_ret->$method($value);
                }
            }
        }

        return $_ret;
    }

        static public function executeQuery($_query) {
        //$_table = self::$table_param["table"];
        //$_primary_key = self::$table_param["primary_key"];
        $_rows = false;
        //echo $_query;

        try {

            DAO::dbConnect();
            $_cursor = DAO::$db->query($_query);
            DAO::$cursor = &$_cursor;

            if (!DbConfig::isError($_cursor)) {
                $numRows = DAO::$cursor->numRows();
                DAO::$numRows = $numRows;

                if ($numRows > 0) {
                    for ($i = 1; $i <= $numRows; $i++) {
                        $_rows[] = DAO::getNextRow();
                    }
                    DAO::$emptySet = false;
                } else {
                    DAO::$emptySet = true;
                }

                /*
                  if ($numRows > 0) {
                  $_row = DAO::$cursor->fetchRow(MDB2_FETCHMODE_ASSOC);
                  DAO::$emptySet = false;
                  } else {
                  DAO::$emptySet = true;
                  }
                 */
            } else {
                DAO::$emptySet = true;
                DAO::$statusResponse = statusResponse::getInstanceForMDBError(DAO::$cursor);
                // error en consulta TODOO debug
            }
        } catch (Exception $e) {
            DAO::$exception = $e;
            DAO::$statusResponse = statusResponse::getInstanceFromException($e);
        }

        return $_rows;
    }

}

?>
