<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

//require_once 'msgTable.php';
//require_once 'customMsgTable.php';

/**
 * Description of statusReponse
 *
 * @author pc1
 */
class statusResponse {

    public $statusCode;
    public $statusMsg;
    public $statusDetail;
    public $debugInfo;
    
    public $attributes;
    public $data;
    public $segment;
    
    private $exception;

    const OK_CODE = 200;
    const OK_MSG = "Operacion exitosa";
    const NOTFOUND_CODE = 500;
        
    const OK_UPDATE_MSG = "Guardado Ok";
    const OK_INSERT_MSG = "Nuevo guardado Ok";
          

    public function statusResponse() {        
    }

    public function getStatusCode() {
        return $this->statusCode;
    }

    public function getStatusMsg() {
        return $this->statusMsg;
    }

    public function getStatusDetail() {
        return $this->statusDetail;
    }

    function getDebugInfo() {
        return $this->debugInfo;
    }

    function setDebugInfo($debugInfo) {
        $this->debugInfo = $debugInfo;
    }

    
    public function getAttributes() {
        return $this->attributes;
    }

    public function setStatusCode($value) {
        $this->statusCode = $value;
    }

    public function setStatusMsg($value) {
        $this->statusMsg = $value;
    }

    public function setStatusDetail($value) {
        $this->statusDetail = $value;
    }


    public function setAttributes($value) {
        $this->attributes = $value;
    }
    
    public function setData($data){
        $this->data = $data;
    }
    
    public function getData() {
        return $this->data;
    }
    
    function getSegment() {
        return $this->segment;
    }

    function setSegment($segment) {
        $this->segment = $segment;
    }
    
    public function toString() {
        return "$this->statusCode | $this->statusMsg | $this->statusDetail ";
    }

    public function isOk() {
        return $this->statusCode == statusResponse::OK_CODE;
    }
    
    public function isNotFound() {
        return $this->statusCode == statusResponse::NOTFOUND_CODE;
    }
    

    /**
     * Retorna un statusResponse intanciado con Ok;
     * @param Exception $e
     * @return statusResponse
     */
    static public function getInstanceOk($msg=false) {
        $_ret = new statusResponse();
        $_ret->exception = null;
        $_ret->statusCode = statusResponse::OK_CODE;
        if (!$msg)
        	$_ret->statusMsg = statusResponse::OK_MSG;
        else 
        	$_ret->statusMsg = $msg;
        $_ret->statusDetail = "";
        $_ret->customMessage = "";
        return $_ret;
    }
    
    /**
     * 
     * 
     */

    /**
     * Retorna un statusResponse intanciado con el mensaje obtenido a partir del codigo
     *
     * @param Exception $e
     * @return statusResponse
     */
    static public function getInstanceFromTableMsgCode($code,$addData="") {
        $_ret = new statusResponse();        
        $_msg = msgTable::getMsgItem($code);
        $_ret->setStatusCode($_msg->code);
        $_ret->setStatusMsg($_msg->msg);
        $_ret->setStatusDetail($_msg->detail . $addData);
        $_ret->setSegment($_msg->segment);
        return $_ret;
    }
    
    
    /**
     * Retorna un statusResponse intanciado con info de la excepcion;
     * @param Exception $e
     * @return statusResponse
     */
    static public function getInstanceFromException(Exception $e) {
        $_ret = new statusResponse();
        $_ret->exception = $e;
        $_ret->statusCode = 505;
        $_ret->statusMsg = "Error de excepcion.";
        $_ret->statusDetail = $e->getMessage();
        $_ret->customMessage = $e->getMessage();
        return $_ret;
    }

    /**
     *
     * @param MDB2_Error $mdb2Error
     * @return statusResponse
     */
    static public function getInstanceForMDBError(MDB2_Error $mdb2Error) {
        $_ret = new statusResponse();
        $_ret->statusMsg = "Error en base de datos.";
        $_ret->statusCode = $mdb2Error->getCode();
        $_ret->statusDetail = $mdb2Error->getMessage();
        $_ret->debugInfo = $mdb2Error->getUserinfo();

        //$_nativeMsg = substr($_ret->statusDetail,strpos($_ret->statusDetail, "Native message"), -2);
        //$_ret->setCustomMessage($_nativeMsg);

        return $_ret;
    }

    public function getJsonEncoded() {
        return json_encode($this,3);
        
    }

    public function getException() {
        return $this->exception = e;
    }

}

?>
